# Snippets

This directory contains snippets of code that can be used as building blocks
for your own tests.  While they don't represent a real life application they
can be compiled following the same instructions as the `mktnotifier`
application.

## `Events`

This directory contains example code for building all messages that the SDK
will *create* and deliver to the application.  Messages generated by other
services (including infrastructure Bloomberg services like '//blp/apiauth' are
not shown here).

## `Resolver`

This directory contains two examples of interactions between an application and
the SDK.  The examples show service registration for a resolution service and
handling of a permission request.

## `RefData`

The `//blp/refdata` service is special in that the schema contains only
requests.  The schema for the responses is dynamically created based on the
data in the request.  Applications cannot just use the schema of the service to
create mock responses in their own tests.  Instead, each test needs to create
the schema that corresponds to the response that will be delivered.
